//+------------------------------------------------------------------+
//|                                             MyCSI_Calculator.mq4 |
//|                                               Erick_Fenstermaker |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Erick_Fenstermaker"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

//Opening a separate window and setting the parameters of the window extents
#property indicator_separate_window
//#property indicator_maximum 100
//#property indicator_minimum -100
//#property indicator_level1 40
//#property indicator_level2 1.75
//#property indicator_level3 -1.75

//Setting up the memory allocation and default settings for the indicator lines
#property indicator_buffers 80
#property indicator_color1 clrPurple
#property indicator_color2 clrRed
#property indicator_color3 clrOrange
#property indicator_color4 clrWhite
#property indicator_color5 clrBlue
#property indicator_color6 clrGreen
#property indicator_color7 clrLightBlue
#property indicator_color8 clrYellow

//Setting up the memory allocation and default settings for the arrows
#property indicator_color9 clrGreen
#property indicator_color10 clrRed

//setting width of lines
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 2
#property indicator_width8 2

//setting width of arrows
#property indicator_width9 1
#property indicator_width10 1

//settings for stochastic lines
extern int Kperiod = 5;
extern int Dperiod = 3;
extern int Slowing = 3;
extern ENUM_MA_METHOD method = MODE_SMA;


   
double lookBackEURGBP[100000];
double lookBackEURAUD[100000];
double lookBackEURNZD[100000];
double lookBackEURUSD[100000];
double lookBackEURCAD[100000];
double lookBackEURCHF[100000];
double lookBackEURJPY[100000];
//Gathers the GBP Symbol close values from the past   
double lookBackGBPAUD[100000];
double lookBackGBPNZD[100000];
double lookBackGBPUSD[100000];
double lookBackGBPCAD[100000];
double lookBackGBPCHF[100000];
double lookBackGBPJPY[100000];
//Gathers the AUD Symbol close values from the past   
double lookBackAUDNZD[100000];
double lookBackAUDUSD[100000];
double lookBackAUDCAD[100000];
double lookBackAUDCHF[100000];
double lookBackAUDJPY[100000];
//Gathers the NZD Symbol close values from the past   
double lookBackNZDUSD[100000];
double lookBackNZDCAD[100000];
double lookBackNZDCHF[100000];
double lookBackNZDJPY[100000];
//Gathers the USD Symbol close values from the past   
double lookBackUSDCAD[100000];
double lookBackUSDCHF[100000];
double lookBackUSDJPY[100000];
//Gathers the CAD Symbol close values from the past   
double lookBackCADCHF[100000];
double lookBackCADJPY[100000];
//Gathers the CHF Symbol close values from the past   
double lookBackCHFJPY[100000];

//Declaring the arrays that will draw the lines for the indicator
double EUR_Band[];
double GBP_Band[];
double AUD_Band[];
double NZD_Band[];
double USD_Band[];
double CAD_Band[];
double CHF_Band[];
double JPY_Band[];

//calculating the percent change from the past close till the current ask of the EUR values
double perEURGBP[100000];
double perEURAUD[100000];
double perEURNZD[100000];
double perEURUSD[100000];
double perEURCAD[100000];
double perEURCHF[100000];
double perEURJPY[100000];

//calculating the percent change from the past close till the current ask of the GBP values
double perGBPAUD[100000];
double perGBPNZD[100000];
double perGBPUSD[100000];
double perGBPCAD[100000];
double perGBPCHF[100000];
double perGBPJPY[100000];

//calculating the percent change from the past close till the current ask of the AUD values
double perAUDNZD[100000];
double perAUDUSD[100000];
double perAUDCAD[100000];
double perAUDCHF[100000];
double perAUDJPY[100000];

//calculating the percent change from the past close till the current ask of the NZD values
double perNZDUSD[100000];
double perNZDCAD[100000];
double perNZDCHF[100000];
double perNZDJPY[100000];

//calculating the percent change from the past close till the current ask of the USD values
double perUSDCAD[100000];
double perUSDCHF[100000];
double perUSDJPY[100000];

//calculating the percent change from the past close till the current ask of the CAD values
double perCADCHF[100000];
double perCADJPY[100000];

//calculating the percent change from the past close till the current ask of the JPY values
double perCHFJPY[100000];


//Array buffers for arrows
double perEUR_uparrow[];
double perEUR_downarrow[];
double perGBP_uparrow[];
double perGBP_downarrow[];
double perAUD_uparrow[];
double perAUD_downarrow[];
double perNZD_uparrow[];
double perNZD_downarrow[];
double perUSD_uparrow[];
double perUSD_downarrow[];
double perCAD_uparrow[];
double perCAD_downarrow[];
double perCHF_uparrow[];
double perCHF_downarrow[];
double perJPY_uparrow[];
double perJPY_downarrow[];

//Sets how far you look into the past (15 min incremints 4 = 1hr)
int lookBack = 16 + 1;
int timeframe = PERIOD_M15;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int OnInit()
  {
//--- indicator buffers mapping for EUR
   SetIndexBuffer(0,EUR_Band);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"EUR Band: ");

//--- indicator buffers mapping for GBP
   SetIndexBuffer(1,GBP_Band);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"GBP Band: ");

//--- indicator buffers mapping for AUD
   SetIndexBuffer(2,AUD_Band);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"AUD Band: ");

//--- indicator buffers mapping for NZD
   SetIndexBuffer(3,NZD_Band);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexLabel(3,"NZD Band: ");

//--- indicator buffers mapping for USD
   SetIndexBuffer(4,USD_Band);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexLabel(4,"USD Band: ");

//--- indicator buffers mapping for CAD
   SetIndexBuffer(5,CAD_Band);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexLabel(5,"CAD Band: ");

//--- indicator buffers mapping for CHF
   SetIndexBuffer(6,CHF_Band);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexLabel(6,"CHF Band: ");

//--- indicator buffers mapping for JPY
   SetIndexBuffer(7,JPY_Band);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexLabel(7,"JPY Band: ");

//--- indicator buffers mapping for buy arrows
   SetIndexBuffer(8,perEUR_uparrow);
   SetIndexStyle(8,DRAW_ARROW);
   SetIndexArrow(8,233);
   SetIndexLabel(8,"Buy Signal");

//--- indicator buffers mapping for sell arrows
   SetIndexBuffer(9,perEUR_downarrow);
   SetIndexStyle(9,DRAW_ARROW);
   SetIndexArrow(9,234);
   SetIndexLabel(9,"Buy Signal");

//---
   return(INIT_SUCCEEDED);
  }
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

//looking at older bars
   int counted_bars, limit;
   counted_bars = IndicatorCounted();
   if(!counted_bars)limit = Bars - 2;
   else limit = Bars - counted_bars - 1;

   for(int i=1; i<= limit; i++)
     {
     
//Gathers the EUR Symbol close values from the past   
lookBackEURGBP[i] = iClose("EURGBP",timeframe,lookBack);
lookBackEURAUD[i] = iClose("EURAUD",timeframe,lookBack);
lookBackEURNZD[i] = iClose("EURNZD",timeframe,lookBack);
lookBackEURUSD[i] = iClose("EURUSD",timeframe,lookBack);
lookBackEURCAD[i] = iClose("EURCAD",timeframe,lookBack);
lookBackEURCHF[i] = iClose("EURCHF",timeframe,lookBack);
lookBackEURJPY[i] = iClose("EURJPY",timeframe,lookBack);
//Gathers the GBP Symbol close values from the past   
lookBackGBPAUD[i] = iClose("GBPAUD",timeframe,lookBack);
lookBackGBPNZD[i] = iClose("GBPNZD",timeframe,lookBack);
lookBackGBPUSD[i] = iClose("GBPUSD",timeframe,lookBack);
lookBackGBPCAD[i] = iClose("GBPCAD",timeframe,lookBack);
lookBackGBPCHF[i] = iClose("GBPCHF",timeframe,lookBack);
lookBackGBPJPY[i] = iClose("GBPJPY",timeframe,lookBack);
//Gathers the AUD Symbol close values from the past   
lookBackAUDNZD[i] = iClose("AUDNZD",timeframe,lookBack);
lookBackAUDUSD[i] = iClose("AUDUSD",timeframe,lookBack);
lookBackAUDCAD[i] = iClose("AUDCAD",timeframe,lookBack);
lookBackAUDCHF[i] = iClose("AUDCHF",timeframe,lookBack);
lookBackAUDJPY[i] = iClose("AUDJPY",timeframe,lookBack);
//Gathers the NZD Symbol close values from the past   
lookBackNZDUSD[i] = iClose("NZDUSD",timeframe,lookBack);
lookBackNZDCAD[i] = iClose("NZDCAD",timeframe,lookBack);
lookBackNZDCHF[i] = iClose("NZDCHF",timeframe,lookBack);
lookBackNZDJPY[i] = iClose("NZDJPY",timeframe,lookBack);
//Gathers the USD Symbol close values from the past   
lookBackUSDCAD[i] = iClose("USDCAD",timeframe,lookBack);
lookBackUSDCHF[i] = iClose("USDCHF",timeframe,lookBack);
lookBackUSDJPY[i] = iClose("USDJPY",timeframe,lookBack);
//Gathers the CAD Symbol close values from the past   
lookBackCADCHF[i] = iClose("CADCHF",timeframe,lookBack);
lookBackCADJPY[i] = iClose("CADJPY",timeframe,lookBack);
//Gathers the CHF Symbol close values from the past   
lookBackCHFJPY[i] = iClose("CHFJPY",timeframe,lookBack);

//Gathers the current EUR Symbol Ask Values
double EURGBP = SymbolInfoDouble("EURGBP", SYMBOL_ASK);
double EURAUD = SymbolInfoDouble("EURAUD", SYMBOL_ASK);
double EURNZD = SymbolInfoDouble("EURNZD", SYMBOL_ASK);
double EURUSD = SymbolInfoDouble("EURUSD", SYMBOL_ASK);
double EURCAD = SymbolInfoDouble("EURCAD", SYMBOL_ASK);
double EURCHF = SymbolInfoDouble("EURCHF", SYMBOL_ASK);
double EURJPY = SymbolInfoDouble("EURJPY", SYMBOL_ASK);
//Gathers the current GBP Symbol Ask Values
double GBPAUD = SymbolInfoDouble("GBPAUD", SYMBOL_ASK);
double GBPNZD = SymbolInfoDouble("GBPNZD", SYMBOL_ASK);
double GBPUSD = SymbolInfoDouble("GBPUSD", SYMBOL_ASK);
double GBPCAD = SymbolInfoDouble("GBPCAD", SYMBOL_ASK);
double GBPCHF = SymbolInfoDouble("GBPCHF", SYMBOL_ASK);
double GBPJPY = SymbolInfoDouble("GBPJPY", SYMBOL_ASK);
//Gathers the current AUD Symbol Ask Values
double AUDNZD = SymbolInfoDouble("AUDNZD", SYMBOL_ASK);
double AUDUSD = SymbolInfoDouble("AUDUSD", SYMBOL_ASK);
double AUDCAD = SymbolInfoDouble("AUDCAD", SYMBOL_ASK);
double AUDCHF = SymbolInfoDouble("AUDCHF", SYMBOL_ASK);
double AUDJPY = SymbolInfoDouble("AUDJPY", SYMBOL_ASK);
//Gathers the current NZD Symbol Ask Values
double NZDUSD = SymbolInfoDouble("NZDUSD", SYMBOL_ASK);
double NZDCAD = SymbolInfoDouble("NZDCAD", SYMBOL_ASK);
double NZDCHF = SymbolInfoDouble("NZDCHF", SYMBOL_ASK);
double NZDJPY = SymbolInfoDouble("NZDJPY", SYMBOL_ASK);
//Gathers the current USD Symbol Ask Values
double USDCAD = SymbolInfoDouble("USDCAD", SYMBOL_ASK);
double USDCHF = SymbolInfoDouble("USDCHF", SYMBOL_ASK);
double USDJPY = SymbolInfoDouble("USDJPY", SYMBOL_ASK);
//Gathers the current CAD Symbol Ask Values
double CADCHF = SymbolInfoDouble("CADCHF", SYMBOL_ASK);
double CADJPY = SymbolInfoDouble("CADJPY", SYMBOL_ASK);
//Gathers the current CHF Symbol Ask Values
double CHFJPY = SymbolInfoDouble("CHFJPY", SYMBOL_ASK);
     
//calculating the percent change from the past close till the current ask of the EUR values
 perEURGBP[i] = (EURGBP - (lookBackEURGBP[i] + (0.0000000001))/(lookBackEURGBP[i] + (0.0000000001)))*100;
 perEURAUD[i] = (EURAUD - (lookBackEURAUD[i] + (0.0000000001))/(lookBackEURAUD[i] + (0.0000000001)))*100;
 perEURNZD[i] = (EURNZD - (lookBackEURNZD[i] + (0.0000000001))/(lookBackEURNZD[i] + (0.0000000001)))*100;
 perEURUSD[i] = (EURUSD - (lookBackEURUSD[i] + (0.0000000001))/(lookBackEURUSD[i] + (0.0000000001)))*100;
 perEURCAD[i] = (EURCAD - (lookBackEURCAD[i] + (0.0000000001))/(lookBackEURCAD[i] + (0.0000000001)))*100;
 perEURCHF[i] = (EURCHF - (lookBackEURCHF[i] + (0.0000000001))/(lookBackEURCHF[i] + (0.0000000001)))*100;
 perEURJPY[i] = (EURJPY - (lookBackEURJPY[i] + (0.0000000001))/(lookBackEURJPY[i] + (0.0000000001)))*100;

//calculating the percent change from the past close till the current ask of the GBP values
 perGBPAUD[i] = (GBPAUD - (lookBackGBPAUD[i] + (0.0000000001))/(lookBackGBPAUD[i] + (0.0000000001)))*100;
 perGBPNZD[i] = (GBPNZD - (lookBackGBPNZD[i] + (0.0000000001))/(lookBackGBPNZD[i] + (0.0000000001)))*100;
 perGBPUSD[i] = (GBPUSD - (lookBackGBPUSD[i] + (0.0000000001))/(lookBackGBPUSD[i] + (0.0000000001)))*100;
 perGBPCAD[i] = (GBPCAD - (lookBackGBPCAD[i] + (0.0000000001))/(lookBackGBPCAD[i] + (0.0000000001)))*100;
 perGBPCHF[i] = (GBPCHF - (lookBackGBPCHF[i] + (0.0000000001))/(lookBackGBPCHF[i] + (0.0000000001)))*100;
 perGBPJPY[i] = (GBPJPY - (lookBackGBPJPY[i] + (0.0000000001))/(lookBackGBPJPY[i] + (0.0000000001)))*100;

//calculating the percent change from the past close till the current ask of the AUD values
 perAUDNZD[i] = (AUDNZD - (lookBackAUDNZD[i] + (0.0000000001))/(lookBackAUDNZD[i] + (0.0000000001)))*100;
 perAUDUSD[i] = (AUDUSD - (lookBackAUDUSD[i] + (0.0000000001))/(lookBackAUDUSD[i] + (0.0000000001)))*100;
 perAUDCAD[i] = (AUDCAD - (lookBackAUDCAD[i] + (0.0000000001))/(lookBackAUDCAD[i] + (0.0000000001)))*100;
 perAUDCHF[i] = (AUDCHF - (lookBackAUDCHF[i] + (0.0000000001))/(lookBackAUDCHF[i] + (0.0000000001)))*100;
 perAUDJPY[i] = (AUDJPY - (lookBackAUDJPY[i] + (0.0000000001))/(lookBackAUDJPY[i] + (0.0000000001)))*100;

//calculating the percent change from the past close till the current ask of the NZD values
 perNZDUSD[i] = (NZDUSD - (lookBackNZDUSD[i] + (0.0000000001))/(lookBackNZDUSD[i] + (0.0000000001)))*100;
 perNZDCAD[i] = (NZDCAD - (lookBackNZDCAD[i] + (0.0000000001))/(lookBackNZDCAD[i] + (0.0000000001)))*100;
 perNZDCHF[i] = (NZDCHF - (lookBackNZDCHF[i] + (0.0000000001))/(lookBackNZDCHF[i] + (0.0000000001)))*100;
 perNZDJPY[i] = (NZDJPY - (lookBackNZDJPY[i] + (0.0000000001))/(lookBackNZDJPY[i] + (0.0000000001)))*100;

//calculating the percent change from the past close till the current ask of the USD values
 perUSDCAD[i] = (USDCAD - (lookBackUSDCAD[i] + (0.0000000001))/(lookBackUSDCAD[i] + (0.0000000001)))*100;
 perUSDCHF[i] = (USDCHF - (lookBackUSDCHF[i] + (0.0000000001))/(lookBackUSDCHF[i] + (0.0000000001)))*100;
 perUSDJPY[i] = (USDJPY - (lookBackUSDJPY[i] + (0.0000000001))/(lookBackUSDJPY[i] + (0.0000000001)))*100;

//calculating the percent change from the past close till the current ask of the CAD values
 perCADCHF[i] = (CADCHF - (lookBackCADCHF[i] + (0.0000000001))/(lookBackCADCHF[i] + (0.0000000001)))*100;
 perCADJPY[i] = (CADJPY - (lookBackCADJPY[i] + (0.0000000001))/(lookBackCADJPY[i] + (0.0000000001)))*100;

//calculating the percent change from the past close till the current ask of the JPY values
 perCHFJPY[i] = (CHFJPY - (lookBackCHFJPY[i] + (0.0000000001))/(lookBackCHFJPY[i] + (0.0000000001)))*100;


//Adds all the percentages from all the pairs together with thier respective pairs
EUR_Band[i] = (perEURGBP[i] + perEURAUD[i] + perEURNZD[i] + perEURUSD[i] + perEURCAD[i] + perEURCHF[i] + perEURJPY[i]);
perEUR_uparrow[i] = (perEURGBP[i] + perEURAUD[i] + perEURNZD[i] + perEURUSD[i] + perEURCAD[i] + perEURCHF[i] + perEURJPY[i]);
perEUR_downarrow[i] = (perEURGBP[i] + perEURAUD[i] + perEURNZD[i] + perEURUSD[i] + perEURCAD[i] + perEURCHF[i] + perEURJPY[i]);

GBP_Band[i] = ((-perEURGBP[i]) + perGBPAUD[i] + perGBPNZD[i] + perGBPUSD[i] + perGBPCAD[i] + perGBPCHF[i] + perGBPJPY[i]);

//double perGBP = ((-perEURGBP) + perGBPAUD + perGBPNZD + perGBPUSD + perGBPCAD + perGBPCHF + perGBPJPY);
//double perAUD = (((-perEURAUD) + (-perGBPAUD)) + perAUDNZD + perAUDUSD + perAUDCAD + perAUDCHF + perAUDJPY);
//double perNZD = (((-perEURNZD) + (-perGBPNZD) + (-perAUDNZD)) + perNZDUSD + perNZDCAD + perNZDCHF + perNZDJPY);
//double perUSD = (((-perEURUSD) + (-perGBPUSD) + (-perAUDUSD) + (-perNZDUSD)) + perUSDCAD + perUSDCHF + perUSDJPY);
//double perCAD = (((-perEURCAD) + (-perGBPCAD) + (-perAUDCAD) + (-perNZDCAD) + (-perUSDCAD)) + perCADCHF + perCADJPY);
//double perCHF = (((-perEURCHF) + (-perGBPCHF) + (-perAUDCHF) + (-perNZDCHF) + (-perUSDCHF) + (-perCADCHF)) + perCHFJPY);
//double perJPY = ((-perEURJPY) + (-perGBPJPY) + (-perAUDJPY) + (-perNZDJPY) + (-perUSDJPY) + (-perCADJPY) + (-perCHFJPY));

    }
   return(rates_total);
  }
//+------------------------------------------------------------------+
